# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .basic_description import BasicDescription

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class CategoryResponse(pydantic.BaseModel):
    """
    Data about a category that can be used to query many datasets and dynamic tags
    """

    created_user_id: str = pydantic.Field(alias="createdUserId", description="The user that created the resource")
    created_dt: dt.datetime = pydantic.Field(alias="createdDt", description="The created datetime of the resource")
    updated_user_id: str = pydantic.Field(alias="updatedUserId", description="The user that last updated the resource")
    updated_dt: dt.datetime = pydantic.Field(
        alias="updatedDt", description="The datetime the resource was last updated"
    )
    category_id: str = pydantic.Field(alias="categoryId", description="The unique identifier for the category")
    name: str = pydantic.Field(description="The name of the category")
    probability_table_paths: typing.Dict[str, typing.Any] = pydantic.Field(
        alias="probabilityTablePaths", description="The category probability table paths"
    )
    datasets: typing.List[BasicDescription] = pydantic.Field(description="The datasets containing the category")
    dynamic_tags: typing.Optional[typing.List[BasicDescription]] = pydantic.Field(
        alias="dynamicTags", description="The dynamic tags within the category"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
